% simple examples of hcfft and nhcfft
%
% Copyright 2009 (c) Michael Doehler, Lutz Kaemmerer, Stefan Kunis, Daniel Potts
%
% $Id: simple_test.m 543 2009-05-13 08:02:06Z skunis $

try
    sptensor();
catch
    fprintf('Tensor toolbox not installed.\n');
    fprintf('For simpler handling of tensor data please install the toolbox\n');
    fprintf('http://csmr.ca.sandia.gov/~tgkolda/TensorToolbox\n');
end





d=4;
n=7;
%n=2;
fprintf('\n*************************************************************************\n');
in=hcfft_initialize(d,n);
A=rand(in.s(d,n+1),1)-1/2;
t=tic;
B=hcfft(A,'notransp','noinv',in);
t1=toc(t);
t=tic;
C=hcdft(A,'notransp', in);
t2=toc(t);
B_C=sum(abs(B-C));
fprintf('simple test of hcfft over hyperbolic cross of dimension d=%d and level n=%d\n',[d,n]);
fprintf('duration of hcfft:                         %d\nduration of hcdft:                         %d\n',[t1,t2]);
fprintf('l_1 norm of hcfft(A)-hcdft(A):             %d\n',B_C);
fprintf('-------------------------------------------------------------------------\n');


d=2;
n=4;
a=3;
m=4;
in=hcfft_initialize(d,n);
in1=hcfft_initialize(d,n+a);
A=rand(in.s(d,n+1),1)-1/2;
x=0:1/2^(n+a):1;
y=0:1/2^(n+a):1;

for j=1:length(y)
    z((j-1)*length(x)+1:j*length(x),:)=[x',ones(length(x),1)*y(j)];
end

%z=rand(in1.s(d,n+a+1),d);
t=tic;
C=nhcdft(A,z,'notransp',in);
t2=toc(t);
t=tic;
B=nhcfft(A,z,m,a,'notransp',in1);
t1=toc(t);
B_C=max(abs(B-C));

fprintf('simple test of nhcfft over hc of dimension d=%d and level n=%d with\noversampling factor alpha=%d and spline order m=%d, points x full grid\n',[d,n,a,m]);
fprintf('duration of nhcfft:                        %d\nduration of nhcdft:                        %d\n',[t1,t2]);
fprintf('maximum norm of nhcfft(A,x)-nhcdft(A,x):   %d\n',B_C);
fprintf('------------------------------------------------------------------------\n');

fprintf('generate figures ...');

B_C=abs(B-C);
clear z;
for j=1:length(y)
    z(:,j)=B_C((j-1)*length(x)+1:j*length(x));
    u(:,j)=abs(C((j-1)*length(x)+1:j*length(x)));
end

figure(1);
mesh(x,y,z);
title('absolute error of nhcdft(A,x)-nhcfft(A,x)');
figure(2);
mesh(x,y,u);
title('abs(nhcdft(A,x))');

fprintf(' figures ready\n');
fprintf('*************************************************************************\n\n');

clear A B C B_C t t1 t2 d n a m x in in1 j y z u;
